# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Defined types

* [`systemd_cron`](#systemd_cron): systemd_cron Create systemd timer/service to replace cron jobs You either need to define on_calendar or on_boot_sec

## Defined types

### <a name="systemd_cron"></a>`systemd_cron`

systemd_cron
Create systemd timer/service to replace cron jobs
You either need to define on_calendar or on_boot_sec

#### Examples

##### Usage

```puppet
systemd_cron { 'date':
  on_calendar         => '*:0/10',
  command             => '/bin/date',
  service_description => 'Print date',
  timer_description   => 'Run date.service every 10 minutes',
}
```

#### Parameters

The following parameters are available in the `systemd_cron` defined type:

* [`on_calendar`](#on_calendar)
* [`on_boot_sec`](#on_boot_sec)
* [`on_unitactive_sec`](#on_unitactive_sec)
* [`command`](#command)
* [`service_description`](#service_description)
* [`ensure`](#ensure)
* [`timer_description`](#timer_description)
* [`type`](#type)
* [`user`](#user)
* [`additional_timer_params`](#additional_timer_params)
* [`additional_service_params`](#additional_service_params)

##### <a name="on_calendar"></a>`on_calendar`

Data type: `Optional[String]`

systemd timer OnCalendar= definition when to run the
service as defined in https://www.freedesktop.org/software/systemd/man/systemd.time.html

Default value: ``undef``

##### <a name="on_boot_sec"></a>`on_boot_sec`

Data type: `Optional[Variant[Integer,String]]`

systemd timer OnBootSec= definition

Default value: ``undef``

##### <a name="on_unitactive_sec"></a>`on_unitactive_sec`

Data type: `Optional[Variant[Integer,String]]`

systemd timer OnUnitActiveSec= definition

Default value: ``undef``

##### <a name="command"></a>`command`

Data type: `Optional[String]`

command string for ExecStart= defintion of the service to run
as defined in https://www.freedesktop.org/software/systemd/man/systemd.service.html

Default value: ``undef``

##### <a name="service_description"></a>`service_description`

Data type: `Optional[String]`

string for Description= defintion of the service
as defined in https://www.freedesktop.org/software/systemd/man/systemd.service.html

Default value: ``undef``

##### <a name="ensure"></a>`ensure`

Data type: `Variant[Boolean,Enum['present','absent']]`

removes the instance if set to false or absent

Default value: ``true``

##### <a name="timer_description"></a>`timer_description`

Data type: `String`

optional string for Description= defintion of the service
as defined in https://www.freedesktop.org/software/systemd/man/systemd.timer.html

Default value: `"timer for ${service_description}"`

##### <a name="type"></a>`type`

Data type: `String`

type of service as defined in
https://www.freedesktop.org/software/systemd/man/systemd.service.html

Default value: `'oneshot'`

##### <a name="user"></a>`user`

Data type: `String`

username to run command User= as defined in
https://www.freedesktop.org/software/systemd/man/systemd.service.html

Default value: `'root'`

##### <a name="additional_timer_params"></a>`additional_timer_params`

Data type: `Optional[Array]`

optional array with lines to append to [Timer] section

example: `'additional_timer_params'   => [ 'RandomizedDelaySec=10' ]`

Default value: ``undef``

##### <a name="additional_service_params"></a>`additional_service_params`

Data type: `Optional[Array]`

optional array with lines to append to [Service] section

example: `'additional_service_params' => [ 'OnFailure=status-email-user@%n.service' ]`

Default value: ``undef``

